#version 130

varying vec2 TexCoords;
varying vec2 LightmapCoords;
varying vec3 Normal;
varying vec4 Color;

uniform sampler2D texture;
uniform int isEyeInWater;

vec3 Norm;
vec3 LC;

void main(){
    vec4 albedo = texture2D(texture, TexCoords) * Color;
	
	float fog;
    if (isEyeInWater > 0) {
        fog = 1.0f - exp(-gl_FogFragCoord * gl_Fog.density);
    } else {
        //fog = clamp((gl_FogFragCoord - gl_Fog.start) * gl_Fog.scale, 0.0f, 1.0f);
    }
	
	if(gl_Fog.color.rgb != vec3(0.0f))
	{
		albedo.rgb = mix(albedo.rgb, gl_Fog.color.rgb, fog);
	    Norm = mix(Normal.rgb, vec3(0.0f), fog);
	    LC = mix(vec3(LightmapCoords, 0.0f), vec3(1.0f), fog);
	}
	else
	{
	    Norm = Normal;
        LC = vec3(LightmapCoords, 0.0f);
	}

    /* DRAWBUFFERS:012 */
    gl_FragData[0] = albedo;
    gl_FragData[1] = vec4(Norm * 0.5f + 0.5f, 1.0f);
    gl_FragData[2] = vec4(LC, 1.0f);
}
